<?php


/**
 * sfJsTreeDoctrine actions.
 * 
 * @package    sfJsTreeDoctrinePlugin
 * @subpackage sfJsTreeDoctrine
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 12534 2008-11-01 13:38:27Z Kris.Wallsmith $
 */
class sfJqueryTreeDoctrineManagerActions extends sfActions
{



  public function getTree($model, $rootId = 0)
  {
    if( $rootId )
    {
      $root = Doctrine_Core::getTable($model)->getTree()->findRoot($rootId);
      return Doctrine_Core::getTable($model)->getTree()->fetchBranch($root->getId()); 
    } else {
      return Doctrine_Core::getTable($model)->getTree()->fetchTree();
    }
  }

  public function executeAdd_child()
  {
    $parent_id = $this->getRequestParameter('parent_id');
    $model = $this->getRequestParameter('model');
    $field = $this->getRequestParameter('field');
    $value = $this->getRequestParameter('value');
    $record = Doctrine_Core::getTable($model)->find($parent_id);

    $child = new $model;
    $child->set($field, $value);
    $record->getNode()->addChild($child);
    $this->json = json_encode($child->toArray());
    $this->getResponse()->setHttpHeader('Content-type', 'application/json');
    $this->setTemplate('json');
  }
  
  public function executeAdd_root()
  {
    $model = $this->getRequestParameter('model');
    $data = $this->getRequestParameter( strtolower($model) );
    $tree = $this->getTree($model);

    $root = new $model;
    $root->synchronizeWithArray( $data );
		$root->save();
		
    Doctrine_Core::getTable($model)->getTree()->createRoot($root);
    $this->records = $this->getTree($model);
    return sfView::NONE;
  }

  public function executeEdit_field()
  {
    $id = $this->getRequestParameter('id');
    $model = $this->getRequestParameter('model');
    $field = $this->getRequestParameter('field');
    $value = $this->getRequestParameter('value');

    //переименовывание листка
    $leafRecord = $this->getLeaf($model, $id);
    if (!empty($leafRecord))
    {
       $leafRecord->set($field, $value);
       $leafRecord->save();
       $record = $leafRecord;
    }
    else
    {
      $record = Doctrine_Core::getTable($model)->find($id);
      $record->set($field, $value);
      $record->save();
    }
    $this->json = json_encode($record->toArray());
    
    $this->getResponse()->setHttpHeader('Content-type', 'application/json');
    $this->setTemplate('json');

  }

  public function executeDelete()
  {
    $id = $this->getRequestParameter('id');
    $model = $this->getRequestParameter('model');
    
    //удаление листка
    $leafRecord = $this->getLeaf($model, $id);
    if (!empty($leafRecord)) $leafRecord->delete();
    
    $record = Doctrine_Core::getTable($model)->find($id);
    $record->getNode()->delete();
    $this->json = json_encode(array());
    $this->getResponse()->setHttpHeader('Content-type', 'application/json');
    $this->setTemplate('json');
    
  }

  public function executeMove()
  {
    $id = $this->getRequestParameter('id');
    $to_id = $this->getRequestParameter('to_id');
    $model = $this->getRequestParameter('model');
    $movetype = $this->getRequestParameter('movetype');
    //если это ветка
    if(is_numeric($id))
    {
       $record = Doctrine_Core::getTable($model)->find($id);
       $dest = Doctrine_Core::getTable($model)->find($to_id);

       if( $movetype == 'inside' )
       {
         $prev = $record->getNode()->getPrevSibling();
         $record->getNode()->moveAsLastChildOf($dest);
       }
       else if( $movetype == 'after' )
       {
         $record->getNode()->moveAsNextSiblingOf($dest);
       }

       else if( $movetype == 'before' )
       {
         $next = $record->getNode()->getNextSibling();
         $record->getNode()->moveAsPrevSiblingOf($dest);
       }
       
    }
    else
    {
      $this->leafMove($model, $id, $to_id);
    }
    $this->json = json_encode($record->toArray());
    $this->getResponse()->setHttpHeader('Content-type', 'application/json');
    $this->setTemplate('json');
    
    
    
  }


  //Функция добавлена мной.
  //Возвращает по названию модели категории и айдишнику листка запись
  //ему соответвующую
  private function getLeaf($model,$id)
  {
    $leafModel = str_replace('Category', '', $model);
    if( preg_match('/^'.$leafModel.'_/',$id))
    {
       $myid = str_replace($leafModel.'_', '', $id);
       $record = Doctrine_Core::getTable($leafModel)->find(array($myid));
       return $record;
    }
  }

  private function leafMove($model,$id,$id_to)
  {
      $leaf = $this->getLeaf($model,$id);
      if (!empty($leaf))
      {
         $dest = $this->getLeaf($model,$id_to);
         if (!empty($dest))
         {
            $categoryId = $dest->getCategoryId();
         }
         else
         {
            $categoryId = $id_to;
         }
         $leaf->setCategoryId($categoryId);
         $leaf->save();
      }


  }

 
}
